Index: cpukit/libblock/src/bdbuf.c
===================================================================
--- cpukit/libblock/src/bdbuf.c	(revision 72d2ec4da4ea788335adf921faebf0ac96d67c93)
+++ cpukit/libblock/src/bdbuf.c	(revision 3899a5379f4bfa067e73b4612a547a308a6634ec)
@@ -1150,656 +1970,403 @@
  */
 static void
-bdbuf_read_transfer_done(void *arg, rtems_status_code status, int error)
-{
-#if defined(READ_MULTIPLE)  
-  
-  read_ahead_bd_buf_group *bd_buf_group = arg;
-  bdbuf_buffer *bd_buf;
-  int i;
-  for (i = 0;i < bd_buf_group->cnt;i++) {
-    bd_buf = bd_buf_group->bd_bufs[i];
-
-    bd_buf->status = status;
-    bd_buf->error = RTEMS_IO_ERROR;
-    _CORE_mutex_Surrender(&bd_buf->transfer_sema, 0, NULL);
-    _CORE_mutex_Flush(&bd_buf->transfer_sema, NULL, 
-                      CORE_MUTEX_STATUS_SUCCESSFUL);
-  }
-#else
-    bdbuf_buffer *bd_buf = arg;
-    bd_buf->status = status;
-    bd_buf->error = RTEMS_IO_ERROR;
-    _CORE_mutex_Surrender(&bd_buf->transfer_sema, 0, NULL);
-    _CORE_mutex_Flush(&bd_buf->transfer_sema, NULL,
-                      CORE_MUTEX_STATUS_SUCCESSFUL);
-#endif
-}
-
-/* rtems_bdbuf_read --
- *     (Similar to the rtems_bdbuf_get, except reading data from media)
- *     Obtain block buffer. If specified block already cached, return address
- *     of appropriate buffer and increment reference counter to 1. If block is
- *     not cached, allocate new buffer and read data to it from the media.
- *     This primitive may be blocked on waiting until data to be read from
- *     media, if there are no free buffer descriptors available and there are
- *     no unused non-modified (or synchronized with media) buffers available.
- *
- * PARAMETERS:
- *     device - device number (consists of major and minor device number)
- *     block  - linear media block number
- *     bd     - address of variable to store pointer to the buffer descriptor
- *
- * RETURNS:
- *     RTEMS status code (RTEMS_SUCCESSFUL if operation completed successfully
- *     or error code if error is occured)
- *
- * SIDE EFFECTS:
- *     bufget_sema and transfer_sema semaphores obtained by this primitive.
- */
-#if !defined(READ_MULTIPLE)
-rtems_status_code
-rtems_bdbuf_read(dev_t device,
-                 blkdev_bnum block,
-                 bdbuf_buffer **bd)
-{
-    preemption_key key;
-    ISR_Level level;
-
-    bdbuf_buffer *bd_buf;
-    rtems_status_code rc;
-    int result;
-    disk_device *dd;
-    disk_device *pdd;
-    blkdev_request1 req;
-
-    dd = rtems_disk_lookup(device);
-    if (dd == NULL)
-        return RTEMS_INVALID_ID;
-
-    if (block >= dd->size)
-    {
-        rtems_disk_release(dd);
-        return RTEMS_INVALID_NUMBER;
-    }
-
-    pdd = dd->phys_dev;
-    block += dd->start;
-
-    DISABLE_PREEMPTION(key);
-    rc = find_or_assign_buffer(pdd, block, &bd_buf);
-
-    if (rc != RTEMS_SUCCESSFUL)
-    {
-        ENABLE_PREEMPTION(key);
-        rtems_disk_release(dd);
-        return rc;
-    }
-
-    if (!bd_buf->actual)
-    {
-        bd_buf->in_progress = 1;
-
-        req.req.req = BLKDEV_REQ_READ;
-        req.req.req_done = bdbuf_read_transfer_done;
-        req.req.done_arg = bd_buf;
-        req.req.start = block;
-        req.req.count = 1;
-        req.req.bufnum = 1;
-        req.req.bufs[0].length = dd->block_size;
-        req.req.bufs[0].buffer = bd_buf->buffer;
-
-        bdbuf_initialize_transfer_sema(bd_buf);
-        result = dd->ioctl(pdd->dev, BLKIO_REQUEST, &req);
-        if (result == -1)
+rtems_bdbuf_write_done(void *arg, rtems_status_code status, int error)
+{
+  rtems_blkdev_request* req = (rtems_blkdev_request*) arg;
+
+  req->error = error;
+  req->status = status;
+
+  rtems_event_send (req->io_task, RTEMS_BDBUF_TRANSFER_SYNC);
+}
+
+/**
+ * Process the modified list of buffers. We can have a sync or modified
+ * list that needs to be handled.
+ */
+static void
+rtems_bdbuf_swapout_modified_processing (rtems_bdpool_id      pid,
+                                         dev_t*               dev,
+                                         rtems_chain_control* chain,
+                                         rtems_chain_control* transfer,
+                                         boolean              sync_active,
+                                         boolean              update_timers,
+                                         uint32_t             timer_delta)
+{
+  if (!rtems_chain_is_empty (chain))
+  {
+    rtems_chain_node* node = rtems_chain_head (chain);
+    node = node->next;
+
+    while (!rtems_chain_is_tail (chain, node))
+    {
+      rtems_bdbuf_buffer* bd = (rtems_bdbuf_buffer*) node;
+    
+      if (bd->pool == pid)
+      {
+        /*
+         * Check if the buffer's hold timer has reached 0. If a sync
+         * is active force all the timers to 0.
+         *
+         * @note Lots of sync requests will skew this timer. It should
+         *       be based on TOD to be accurate. Does it matter ?
+         */
+        if (sync_active)
+          bd->hold_timer = 0;
+  
+        if (bd->hold_timer)
         {
-            bd_buf->status = RTEMS_IO_ERROR;
-            bd_buf->error = errno;
-            bd_buf->actual = FALSE;
+          if (update_timers)
+          {
+            if (bd->hold_timer > timer_delta)
+              bd->hold_timer -= timer_delta;
+            else
+              bd->hold_timer = 0;
+          }
+
+          if (bd->hold_timer)
+          {
+            node = node->next;
+            continue;
+          }
+        }
+
+        /*
+         * This assumes we can set dev_t to -1 which is just an
+         * assumption. Cannot use the transfer list being empty
+         * the sync dev calls sets the dev to use.
+         */
+        if (*dev == -1)
+          *dev = bd->dev;
+
+        if (bd->dev == *dev)
+        {
+          rtems_chain_node* next_node = node->next;
+          rtems_chain_extract (node);
+          rtems_chain_append (transfer, node);
+          node = next_node;
+          bd->state = RTEMS_BDBUF_STATE_TRANSFER;
         }
         else
         {
-            rtems_interrupt_disable(level);
-            _CORE_mutex_Seize(&bd_buf->transfer_sema, 0, TRUE,
-                              WATCHDOG_NO_TIMEOUT, level);
-            bd_buf->actual = TRUE;
+          node = node->next;
         }
-        bd_buf->in_progress = FALSE;
-    }
-    rtems_disk_release(dd);
-
-    ENABLE_PREEMPTION(key);
-
-    *bd = bd_buf;
-           
-    return RTEMS_SUCCESSFUL;
-}
-#else /* READ_MULTIPLE */
-rtems_status_code
-rtems_bdbuf_read(dev_t device, 
-                 blkdev_bnum block,
-                 bdbuf_buffer **bd)
-{
-    preemption_key key;
-    ISR_Level level;
-
-    bdbuf_buffer *bd_buf,*first_bd_buf;
-    rtems_status_code rc;
-    int result;
-    disk_device *dd;
-    disk_device *pdd;
-    blkdev_request_read_ahead req;
-    read_ahead_bd_buf_group bd_buf_group;
-    boolean find_more_buffers;
-    int i;
-
-    dd = rtems_disk_lookup(device);
+      }
+    }
+  }
+}
+
+/**
+ * Process the pool.
+ */
+static boolean
+rtems_bdbuf_swapout_pool_processing (rtems_bdpool_id       pid,
+                                     unsigned long         timer_delta,
+                                     boolean               update_timers,
+                                     rtems_blkdev_request* write_req)
+{
+  rtems_bdbuf_pool*   pool = rtems_bdbuf_get_pool (pid);
+  rtems_chain_control transfer;
+  dev_t               dev = -1;
+  rtems_disk_device*  dd;
+  boolean             result = TRUE;
+
+  rtems_chain_initialize_empty (&transfer);
+    
+  rtems_bdbuf_lock_pool (pool);
+
+  if (pool->sync_active)
+    dev = pool->sync_device;
+
+#if 1
+  /*
+   * If we have any buffers in the sync queue move then to the
+   * modified list. The first sync buffer will select the
+   * device we use.
+   */
+  rtems_bdbuf_swapout_modified_processing (pid, &dev,
+                                           &pool->sync, &transfer,
+                                           TRUE, FALSE,
+                                           timer_delta);
+
+  /*
+   * Process the pool's modified list.
+   */
+  rtems_bdbuf_swapout_modified_processing (pid, &dev,
+                                           &pool->modified, &transfer,
+                                           pool->sync_active,
+                                           update_timers,
+                                           timer_delta);
+
+  /*
+   * We have all the buffers that have been modified for this device so
+   * the pool can be unlocked because the state is set to TRANSFER.
+   */
+#endif
+  rtems_bdbuf_unlock_pool (pool);
+
+  /*
+   * If there are buffers to transfer to the media tranfer them.
+   */
+  if (rtems_chain_is_empty (&transfer))
+    result = FALSE;
+  else
+  {
+    /*
+     * Obtain the disk device. Release the pool mutex to avoid a dead
+     * lock.
+     */
+    dd = rtems_disk_obtain (dev);
     if (dd == NULL)
-        return RTEMS_INVALID_ID;
-     
-    if (block >= dd->size)
-    {
-        rtems_disk_release(dd);
-        return RTEMS_INVALID_NUMBER;
-    }
-    
-    pdd = dd->phys_dev;
-    block += dd->start;
-
-    DISABLE_PREEMPTION(key);
-    rc = find_or_assign_buffer(pdd, block, &first_bd_buf);
-
-    if (rc != RTEMS_SUCCESSFUL)
-    {
-        ENABLE_PREEMPTION(key);
-        rtems_disk_release(dd);
-        return rc;
-    }
-    if (!first_bd_buf->actual)
-    {
-
-	bd_buf_group.bd_bufs[0] = first_bd_buf;
-	bd_buf_group.cnt = 1;
-
-        first_bd_buf->in_progress = TRUE;
-
-        req.req.req = BLKDEV_REQ_READ;
-        req.req.req_done = bdbuf_read_transfer_done;
-        req.req.done_arg = &bd_buf_group;
-        req.req.start = block;
-        req.req.count = 1;
-        req.req.bufnum = 1;
-        req.req.bufs[0].length = dd->block_size;
-        req.req.bufs[0].buffer = first_bd_buf->buffer;
+      result = FALSE;
+    else
+    {
+      /*
+       * The last block number used when the driver only supports
+       * continuous blocks in a single request.
+       */
+      uint32_t last_block = 0;
+      
+      /*
+       * Take as many buffers are configured and pass to the driver. Note,
+       * the API to the drivers has the array of buffers and if a chain was
+       * passed we could have just passed the list. If the driver API is
+       * updated it should be possible to make this change with little effect
+       * in this code. The array that is passed is broken in design and
+       * should be removed. Merging to members of a struct into the first
+       * member is trouble waiting to happen.
+       */
+
+      write_req->status = RTEMS_RESOURCE_IN_USE;
+      write_req->start = dd->start;
+      write_req->error = 0;
+      write_req->count = 0;
+      write_req->bufnum = 0;
+
+      while (!rtems_chain_is_empty (&transfer))
+      {
+        rtems_bdbuf_buffer* bd =
+          (rtems_bdbuf_buffer*) rtems_chain_get (&transfer);
+
+        boolean write = FALSE;
         
-        bdbuf_initialize_transfer_sema(first_bd_buf);
-	/*
-	 * FIXME: check for following blocks to be:
-	 *   - still in range of partition size
-	 *   - not yet assigned
-	 *   - buffer available
-	 * allocate for read call, if possible
-	 */
-	find_more_buffers = TRUE;
-	while (find_more_buffers) {	  
-	  block++;
-	  /*
-	   * still bd_buf_group entries free and 
-	   * still in range of this disk? 
-	   */
-	  if ((bd_buf_group.cnt >= READ_AHEAD_MAX_BLK_CNT) ||
-	      (block >= dd->size)) {
-	    find_more_buffers = FALSE;
-	  }
-	  if (find_more_buffers) {
-	    rc = find_or_assign_buffer(pdd, block, &bd_buf);
-	    if (rc != RTEMS_SUCCESSFUL) {
-	      find_more_buffers = FALSE;
-	    }      
-	    else if (bd_buf->actual) {
-	      find_more_buffers = FALSE;
-          bdbuf_release(bd_buf);
-	    }      
-	  }
-	  if (find_more_buffers) {
-	    bdbuf_initialize_transfer_sema(bd_buf);
-	    bd_buf->in_progress = TRUE;
-
-	    req.req.bufs[req.req.count].length = dd->block_size;
-	    req.req.bufs[req.req.count].buffer = bd_buf->buffer;
-	    req.req.count++;
-	    req.req.bufnum++;
-	    bd_buf_group.bd_bufs[bd_buf_group.cnt] = bd_buf;
-	    bd_buf_group.cnt++;
-	  }
-	}	    
-
-	/* do the actual read call here 
-	 */
-        result = dd->ioctl(pdd->dev, BLKIO_REQUEST, &req);
-
-	/*
-	 * cleanup: 
-	 * wait, until all bd_bufs are processed
-	 * set status in all bd_bufs
-	 */
-	for (i = 0;i < bd_buf_group.cnt;i++) {
-	  bd_buf = bd_buf_group.bd_bufs[i];
-	  if (result == -1)
-	    {
-	      bd_buf->status = RTEMS_IO_ERROR;
-	      bd_buf->error = errno;
-	      bd_buf->actual = FALSE;
-	    }
-	  else
-	    {
-	      rtems_interrupt_disable(level);
-	      _CORE_mutex_Seize(&bd_buf->transfer_sema, 0, TRUE,
-				WATCHDOG_NO_TIMEOUT, level);
-	      bd_buf->actual = TRUE;
-	    }	
-	  bd_buf->in_progress = FALSE;
-	  /* release any pre-read buffers */
-	  if (i > 0) {
-	    bdbuf_release(bd_buf);
-	  }
-	}
-    }
-    rtems_disk_release(dd);
-    
-    ENABLE_PREEMPTION(key);
-
-    *bd = first_bd_buf;
-           
-    return RTEMS_SUCCESSFUL;
-}
-#endif /* READ_MULTIPLE */
-
-
-/* bdbuf_release --
- *     Release buffer. Decrease buffer usage counter. If it is zero, further
- *     processing depends on modified attribute. If buffer was modified, it
- *     is inserted into mod chain and swapout task waken up. If buffer was
- *     not modified, it is returned to the end of lru chain making it available
- *     for further use.
- *
- * PARAMETERS:
- *     bd_buf - pointer to the released buffer descriptor.
- *
- * RETURNS:
- *     RTEMS_SUCCESSFUL if buffer released successfully, or error code if
- *     error occured.
- *
- * NOTE:
- *     This is internal function. It is assumed that task made non-preemptive
- *     before its invocation.
- */
-static rtems_status_code
-bdbuf_release(bdbuf_buffer *bd_buf)
-{
-    bdbuf_pool *bd_pool;
-    rtems_status_code rc = RTEMS_SUCCESSFUL;
-
-    if (bd_buf->use_count <= 0)
-        return RTEMS_INTERNAL_ERROR;
-
-    bd_pool = rtems_bdbuf_ctx.pool + bd_buf->pool;
-
-    bd_buf->use_count--;
-
-    if (bd_buf->use_count == 0)
-    {
-        if (bd_buf->modified)
+        /*
+         * If the device only accepts sequential buffers and
+         * this is not the first buffer (the first is always
+         * sequential, and the buffer is not sequential then
+         * put the buffer back on the transfer chain and
+         * write the committed buffers.
+         */
+        
+        if ((dd->capabilities & RTEMS_BLKDEV_CAP_MULTISECTOR_CONT) &&
+            write_req->count &&
+            (bd->block != (last_block + 1)))
         {
-
-            /* Buffer was modified. Insert buffer to the modified buffers
-             * list and initiate flushing. */
-            rtems_chain_append(&rtems_bdbuf_ctx.mod, &bd_buf->link);
-
-            /* Release the flush_sema */
-            rc = rtems_semaphore_release(rtems_bdbuf_ctx.flush_sema);
+          rtems_chain_prepend (&transfer, &bd->link);
+          write = TRUE;
         }
         else
         {
-            /* Buffer was not modified. Add this descriptor to the
-             * end of lru chain and make it available for reuse. */
-            rtems_chain_append(&bd_pool->lru, &bd_buf->link);
-            rc = rtems_semaphore_release(bd_pool->bufget_sema);
+          write_req->bufs[write_req->count].user   = bd;
+          write_req->bufs[write_req->count].block  = bd->block;
+          write_req->bufs[write_req->count].length = dd->block_size;
+          write_req->bufs[write_req->count].buffer = bd->buffer;
+          write_req->count++;
+          write_req->bufnum++;
+          last_block = bd->block;
         }
-    }
-    return rc;
-}
-
-
-/* rtems_bdbuf_release --
- *     Release buffer allocated before. This primitive decrease the
- *     usage counter. If it is zero, further destiny of buffer depends on
- *     'modified' status. If buffer was modified, it is placed to the end of
- *     mod list and flush task waken up. If buffer was not modified,
- *     it is placed to the end of lru list, and bufget_sema released, allowing
- *     to reuse this buffer.
- *
- * PARAMETERS:
- *     bd_buf - pointer to the bdbuf_buffer structure previously obtained using
- *              get/read primitive.
- *
- * RETURNS:
- *     RTEMS status code (RTEMS_SUCCESSFUL if operation completed successfully
- *     or error code if error is occured)
- *
- * SIDE EFFECTS:
- *     flush_sema and bufget_sema semaphores may be released by this primitive.
- */
-rtems_status_code
-rtems_bdbuf_release(bdbuf_buffer *bd_buf)
-{
-    preemption_key key;
-    rtems_status_code rc = RTEMS_SUCCESSFUL;
-
-    if (bd_buf == NULL)
-        return RTEMS_INVALID_ADDRESS;
-
-    DISABLE_PREEMPTION(key);
-
-    rc = bdbuf_release(bd_buf);
-
-    ENABLE_PREEMPTION(key);
-
-    return rc;
-}
-
-/* rtems_bdbuf_release_modified --
- *     Release buffer allocated before, assuming that it is _modified_ by
- *     it's owner. This primitive decrease usage counter for buffer, mark
- *     buffer descriptor as modified. If usage counter is 0, insert it at
- *     end of mod chain and release flush_sema semaphore to activate the
- *     flush task.
- *
- * PARAMETERS:
- *     bd_buf - pointer to the bdbuf_buffer structure previously obtained using
- *              get/read primitive.
- *
- * RETURNS:
- *     RTEMS status code (RTEMS_SUCCESSFUL if operation completed successfully
- *     or error code if error is occured)
- *
- * SIDE EFFECTS:
- *     flush_sema semaphore may be released by this primitive.
- */
-rtems_status_code
-rtems_bdbuf_release_modified(bdbuf_buffer *bd_buf)
-{
-    preemption_key key;
-    rtems_status_code rc = RTEMS_SUCCESSFUL;
-
-    if (bd_buf == NULL)
-        return RTEMS_INVALID_ADDRESS;
-
-    DISABLE_PREEMPTION(key);
-
-    if (!bd_buf->modified)
-    {
-        bdbuf_initialize_transfer_sema(bd_buf);
-    }
-    bd_buf->modified = TRUE;
-    bd_buf->actual = TRUE;
-    rc = bdbuf_release(bd_buf);
-
-    ENABLE_PREEMPTION(key);
-
-    return rc;
-}
-
-/* rtems_bdbuf_sync --
- *     Wait until specified buffer synchronized with disk. Invoked on exchanges
- *     critical for data consistency on the media. This primitive mark owned
- *     block as modified, decrease usage counter. If usage counter is 0,
- *     block inserted to the mod chain and flush_sema semaphore released.
- *     Finally, primitives blocked on transfer_sema semaphore.
- *
- * PARAMETERS:
- *     bd_buf - pointer to the bdbuf_buffer structure previously obtained using
- *              get/read primitive.
- *
- * RETURNS:
- *     RTEMS status code (RTEMS_SUCCESSFUL if operation completed successfully
- *     or error code if error is occured)
- *
- * SIDE EFFECTS:
- *     Primitive may be blocked on transfer_sema semaphore.
- */
-rtems_status_code
-rtems_bdbuf_sync(bdbuf_buffer *bd_buf)
-{
-    preemption_key key;
-    ISR_Level level;
-    rtems_status_code rc = RTEMS_SUCCESSFUL;
-
-    if (bd_buf == NULL)
-        return RTEMS_INVALID_ADDRESS;
-
-    DISABLE_PREEMPTION(key);
-
-    if (!bd_buf->modified)
-    {
-        bdbuf_initialize_transfer_sema(bd_buf);
-    }
-    bd_buf->modified = TRUE;
-    bd_buf->actual = TRUE;
-
-    rc = bdbuf_release(bd_buf);
-
-    if (rc == RTEMS_SUCCESSFUL)
-    {
-        rtems_interrupt_disable(level);
-        _CORE_mutex_Seize(&bd_buf->transfer_sema, 0, TRUE,
-                          WATCHDOG_NO_TIMEOUT, level);
-    }
-
-    ENABLE_PREEMPTION(key);
-
-    return rc;
-}
-
-/* rtems_bdbuf_syncdev --
- *     Synchronize with disk all buffers containing the blocks belonging to
- *     specified device.
- *
- * PARAMETERS:
- *     dev - block device number
- *
- * RETURNS:
- *     RTEMS status code (RTEMS_SUCCESSFUL if operation completed successfully
- *     or error code if error is occured)
- */
-rtems_status_code
-rtems_bdbuf_syncdev(dev_t dev)
-{
-    preemption_key key;
-    ISR_Level level;
-
-    bdbuf_buffer *bd_buf;
-    disk_device *dd;
-    bdbuf_pool  *pool;
-
-    dd = rtems_disk_lookup(dev);
-    if (dd == NULL)
-        return RTEMS_INVALID_ID;
-
-    pool = rtems_bdbuf_ctx.pool + dd->pool;
-
-    DISABLE_PREEMPTION(key);
-    do {
-        bd_buf = avl_search_for_sync(&pool->tree, dd);
-        if (bd_buf != NULL /* && bd_buf->modified */)
+
+        /*
+         * Perform the transfer if there are no more buffers, or the
+         * transfer size has reached the configured max. value.
+         */
+
+        if (rtems_chain_is_empty (&transfer) ||
+            (write_req->count >= rtems_bdbuf_configuration.max_write_blocks))
+          write = TRUE;
+
+        if (write)
         {
-            rtems_interrupt_disable(level);
-            _CORE_mutex_Seize(&bd_buf->transfer_sema, 0, TRUE,
-                              WATCHDOG_NO_TIMEOUT, level);
+          int result;
+          int b;
+
+          /*
+           * Perform the transfer. No pool locks, no preemption, only the
+           * disk device is being held.
+           */
+          result = dd->ioctl (dd->phys_dev->dev,
+                              RTEMS_BLKIO_REQUEST, write_req);
+
+          if (result < 0)
+          {
+            rtems_bdbuf_lock_pool (pool);
+              
+            for (b = 0; b < write_req->count; b++)
+            {
+              bd = write_req->bufs[b].user;
+              bd->state  = RTEMS_BDBUF_STATE_MODIFIED;
+              bd->error = errno;
+
+              /*
+               * Place back on the pools modified queue and try again.
+               *
+               * @warning Not sure this is the best option but I do
+               *          not know what else can be done.
+               */
+              rtems_chain_append (&pool->modified, &bd->link);
+            }
+          }
+          else
+          {
+            rtems_status_code sc = 0;
+            rtems_event_set   out;
+
+            sc = rtems_event_receive (RTEMS_BDBUF_TRANSFER_SYNC,
+                                      RTEMS_EVENT_ALL | RTEMS_WAIT,
+                                      0, &out);
+
+            if (sc != RTEMS_SUCCESSFUL)
+              rtems_fatal_error_occurred (BLKDEV_FATAL_BDBUF_SWAPOUT_RE);
+
+            rtems_bdbuf_lock_pool (pool);
+
+            for (b = 0; b < write_req->count; b++)
+            {
+              bd = write_req->bufs[b].user;
+              bd->state = RTEMS_BDBUF_STATE_CACHED;
+              bd->error = 0;
+
+              rtems_chain_append (&pool->lru, &bd->link);
+              
+              if (bd->waiters)
+                rtems_bdbuf_wake (pool->transfer, &pool->transfer_waiters);
+              else
+              {
+                if (rtems_chain_has_only_one_node (&pool->lru))
+                  rtems_bdbuf_wake (pool->waiting, &pool->wait_waiters);
+              }
+            }
+          }
+
+          rtems_bdbuf_unlock_pool (pool);
+
+          write_req->status = RTEMS_RESOURCE_IN_USE;
+          write_req->error = 0;
+          write_req->count = 0;
+          write_req->bufnum = 0;
         }
-    } while (bd_buf != NULL);
-    ENABLE_PREEMPTION(key);
-    return rtems_disk_release(dd);
-}
-
-/* bdbuf_swapout_task --
- *     Body of task which take care on flushing modified buffers to the
- *     disk.
+      }
+          
+      rtems_disk_release (dd);
+    }
+  }
+
+  if (pool->sync_active)
+    rtems_event_send (pool->sync_requester, RTEMS_BDBUF_TRANSFER_SYNC);
+  
+  return result;
+}
+
+/**
+ * Body of task which take care on flushing modified buffers to the disk.
  */
 static rtems_task
-bdbuf_swapout_task(rtems_task_argument unused)
-{
-    rtems_status_code rc;
-    int result;
-    int i;
-    ISR_Level level;
-    bdbuf_buffer *bd_buf;
-    bdbuf_buffer *nxt_bd_buf;
-    bdbuf_pool *bd_pool = NULL;
-    disk_device *dd = NULL;
-    struct {
-      blkdev_request   req;
-      blkdev_sg_buffer sg[SWAP_OUT_MAX_BLK_CNT];
-    } req;
-    write_tfer_done_arg_t write_tfer_done_arg;
+rtems_bdbuf_swapout_task (rtems_task_argument arg)
+{
+  rtems_bdbuf_context*  context = (rtems_bdbuf_context*) arg;
+  rtems_blkdev_request* write_req;
+  uint32_t              period_in_ticks;
+  const uint32_t        period_in_msecs = rtems_bdbuf_configuration.swapout_period;
+  uint32_t              timer_delta;
+  rtems_status_code     sc;
+
+  /*
+   * @note chrisj The rtems_blkdev_request and the array at the end is a hack.
+   * I am disappointment at finding code like this in RTEMS. The request should
+   * have been a rtems_chain_control. Simple, fast and less storage as the node
+   * is already part of the buffer structure.
+   */
+  write_req =
+    malloc (sizeof (rtems_blkdev_request) +
+            (rtems_bdbuf_configuration.max_write_blocks *
+             sizeof (rtems_blkdev_sg_buffer)));
+
+  if (!write_req)
+    rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_SO_NOMEM);
+
+  write_req->req = RTEMS_BLKDEV_REQ_WRITE;
+  write_req->req_done = rtems_bdbuf_write_done;
+  write_req->done_arg = write_req;
+  write_req->io_task = rtems_task_self ();
+
+  period_in_ticks = TOD_MICROSECONDS_TO_TICKS (period_in_msecs * 1000);
+
+  /*
+   * This is temporary. Needs to be changed to use the real clock.
+   */
+  timer_delta = period_in_msecs;
+
+  while (context->swapout_enabled)
+  {
+    rtems_event_set out;
 
     /*
-     * provide info needed for write_transfer_done function
+     * Only update the timers once in the processing cycle.
      */
-    write_tfer_done_arg.req         = (blkdev_request *)&req.req;
-    write_tfer_done_arg.write_store =  bd_buf_write_store;
-    nxt_bd_buf = NULL;
-    while (1)
-    {
-	req.req.req = BLKDEV_REQ_WRITE;
-	req.req.req_done = bdbuf_write_transfer_done;
-	req.req.done_arg = &write_tfer_done_arg;
-	req.req.count = 0;
-	req.req.bufnum = 0;
-	bd_buf = NULL;
-	do {
-	  /*
-	   * if a buffer was left over from last loop, then use this buffer
-	   * otherwise fetch new buffer from chain. 
-	   * Wait for buffer, if this is the first one of the request,
-	   * otherwise do not wait, if no buffer available
-	   */
-	  if (nxt_bd_buf == NULL) {
-	    rc = rtems_semaphore_obtain(rtems_bdbuf_ctx.flush_sema, 
-					(req.req.count == 0)
-					? RTEMS_WAIT
-					: RTEMS_NO_WAIT, 
-					0);
-	    if (rc == RTEMS_SUCCESSFUL) {
-	      nxt_bd_buf = (bdbuf_buffer *)rtems_chain_get(&rtems_bdbuf_ctx.mod);
-          if (nxt_bd_buf != NULL) {
-  	        nxt_bd_buf->in_progress = TRUE;
-            /* IMD try: clear "modified" bit early             */
-            /* (and not in bdbuf_write_transfer_done) to allow */
-            /* another modification during write processing    */
-            nxt_bd_buf->modified    = FALSE;
-
-	        nxt_bd_buf->use_count++;
-		  }
-	    }
-	    else if ((rc != RTEMS_UNSATISFIED) && 
-		     (rc != RTEMS_TIMEOUT)) {
-	      rtems_fatal_error_occurred(BLKDEV_FATAL_BDBUF_SWAPOUT);
-	    }
-	  }
-	  /* 
-	   * It is possible that flush_sema semaphore will be released, but
-	   * buffer to be removed from mod chain before swapout task start
-	   * its processing. 
-	   */
-	  if ((req.req.count == 0)  || /* first bd_buf for this request */
-	      ((nxt_bd_buf        != NULL)            && 
-	       (nxt_bd_buf->dev   == bd_buf->dev)     && /* same device */
-	       (nxt_bd_buf->block == bd_buf->block+1))) {/* next block  */
-	    bd_buf     = nxt_bd_buf;
-	    nxt_bd_buf = NULL;
-	  }
-	  else {
-	    bd_buf = NULL;
-	  }
-	  /*
-	   * here we have three possible states:
-	   * bd_buf == NULL, nxt_bd_buf == NULL: no further block available
-	   * bd_buf != NULL, nxt_bd_buf == NULL: append bd_buf to request
-	   * bd_buf == NULL, nxt_bd_buf != NULL: nxt_bd_buf canot be appended 
-	   *                                     to current request, keep it
-	   *                                     for next main loop
-	   */
-	  if (bd_buf != NULL) {
-	    bd_pool = rtems_bdbuf_ctx.pool + bd_buf->pool;
-	    if (req.req.count == 0) {
-	      /*
-	       * this is the first block, so use its address
-	       */
-	      dd = rtems_disk_lookup(bd_buf->dev);
-	      req.req.start = bd_buf->block + dd->start;
-	    }
-	    req.req.bufs[req.req.bufnum].length = dd->block_size;
-	    req.req.bufs[req.req.bufnum].buffer = bd_buf->buffer;
-	    /*
-	     * keep bd_buf for postprocessing
-	     */
-	    bd_buf_write_store[req.req.bufnum] = bd_buf;
-	    req.req.count++;
-	    req.req.bufnum++;
-	  }
-	} while ((bd_buf != NULL) &&
-		 (req.req.count < SWAP_OUT_MAX_BLK_CNT));
-		 
-        /* transfer_sema initialized when bd_buf inserted in the mod chain 
-           first time */
-        result = dd->ioctl(dd->phys_dev->dev, BLKIO_REQUEST, &req);
-
-        rtems_disk_release(dd);
-        
-	for (i = 0;i < req.req.count;i++) {
-	  bd_buf = bd_buf_write_store[i];
-	  if (result == -1)
-	    {
-	      
-	      bd_buf->status = RTEMS_IO_ERROR;
-	      bd_buf->error = errno;
-	      /* Release tasks waiting on syncing this buffer */
-	      _CORE_mutex_Flush(&bd_buf->transfer_sema, NULL,
-				CORE_MUTEX_STATUS_SUCCESSFUL);
-	    }
-	  else
-	    {
-	      if (bd_buf->in_progress)
-		{
-		  rtems_interrupt_disable(level);
-		  _CORE_mutex_Seize(&bd_buf->transfer_sema, 0, TRUE, 0, level);
-		}
-	    }
-	  bd_buf->use_count--;
-
-	  /* Another task have chance to use this buffer, or even
-	   * modify it. If buffer is not in use, insert it in appropriate chain
-	   * and release semaphore */
-	  if (bd_buf->use_count == 0)
-	    {
-	      if (bd_buf->modified)
-		{
-		  rtems_chain_append(&rtems_bdbuf_ctx.mod, &bd_buf->link);
-		  rc = rtems_semaphore_release(rtems_bdbuf_ctx.flush_sema);
-		}
-	      else
-		{
-		  rtems_chain_append(&bd_pool->lru, &bd_buf->link);
-		  rc = rtems_semaphore_release(bd_pool->bufget_sema);
-		}
-	    }
+    boolean update_timers = TRUE;
+    
+    /*
+     * If we write buffers to any disk perform a check again. We only
+     * write a single device at a time and a pool may have more than
+     * one devices buffers modified waiting to be written.
+     */
+    boolean transfered_buffers;
+
+    do
+    {
+      rtems_bdpool_id pid;
+    
+      transfered_buffers = FALSE;
+
+      /*
+       * Loop over each pool extacting all the buffers we find for a specific
+       * device. The device is the first one we find on a modified list of a
+       * pool. Process the sync queue of buffers first.
+       */
+      for (pid = 0; pid < context->npools; pid++)
+      {
+        if (rtems_bdbuf_swapout_pool_processing (pid,
+                                                 timer_delta,
+                                                 update_timers,
+                                                 write_req))
+        {
+          transfered_buffers = TRUE;
         }
-    }
-}
-
-/* rtems_bdbuf_find_pool --
- *     Find first appropriate buffer pool. This primitive returns the index
- *     of first buffer pool which block size is greater than or equal to
- *     specified size.
+      }
+
+      /*
+       * Only update the timers once.
+       */
+      update_timers = FALSE;
+    }
+    while (transfered_buffers);
+
+    sc = rtems_event_receive (RTEMS_BDBUF_SWAPOUT_SYNC,
+                              RTEMS_EVENT_ALL | RTEMS_WAIT,
+                              period_in_ticks,
+                              &out);
+
+    if ((sc != RTEMS_SUCCESSFUL) && (sc != RTEMS_TIMEOUT))
+      rtems_fatal_error_occurred (BLKDEV_FATAL_BDBUF_SWAPOUT_RE);
+  }
+
+  free (write_req);
+
+  rtems_task_delete (RTEMS_SELF);
+}
+
+/**
+ * Find first appropriate buffer pool. This primitive returns the index of
+ * first buffer pool which block size is greater than or equal to specified
+ * size.
  *
  * PARAMETERS:
